'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = CloneButton;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactIntl = require('react-intl');

var _cspaceInput = require('cspace-input');

var _CloneButton = require('../../../styles/cspace-ui/CloneButton.css');

var _CloneButton2 = _interopRequireDefault(_CloneButton);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Button = _cspaceInput.components.Button;


var messages = (0, _reactIntl.defineMessages)({
  label: {
    'id': 'cloneButton.label',
    'defaultMessage': 'Clone'
  }
});

var propTypes = {
  csid: _propTypes2.default.string,
  isModified: _propTypes2.default.bool,
  isSavePending: _propTypes2.default.bool,
  relatedSubjectWorkflowState: _propTypes2.default.string,
  onClick: _propTypes2.default.func
};

function CloneButton(props) {
  var csid = props.csid,
      isModified = props.isModified,
      isSavePending = props.isSavePending,
      relatedSubjectWorkflowState = props.relatedSubjectWorkflowState,
      onClick = props.onClick;


  if (!csid) {
    return null;
  }

  if (relatedSubjectWorkflowState === 'locked') {
    // We're editing an object record in a secondary tab, and the primary record is locked. This
    // means a new cloned record would not be able to be related to the primary, so the clone
    // button should not appear.

    return null;
  }

  return _react2.default.createElement(
    Button,
    {
      className: _CloneButton2.default.common,
      disabled: isModified || isSavePending,
      icon: true,
      name: 'clone',
      onClick: onClick
    },
    _react2.default.createElement(_reactIntl.FormattedMessage, messages.label)
  );
}

CloneButton.propTypes = propTypes;